//+------------------------------------------------------------------+
//|   Kiko - EA basada en indicador VQ                               |
//|   Kiko_v2 by Big Be, Jan. 08                                     |
//|   Kiko_v2.1 by Big Be, Feb. 08 minor corrections                                                               |
//+------------------------------------------------------------------+

#property copyright "Mnica Primo"
extern int     MagicNumber = 3359;
extern double  TakeProfit  =  80;
extern double  StopLoss    =  50;
extern double  Lots     = 0.4;

extern double     MaximumRisk             = 0.05;     //
extern int        DecreaseFactor          = 0;        //
extern bool       MM                      = false;     //Money management
extern bool       AccountIsMicro          = true;	//Micro means 0.01 lot size is allowed

int  slippage=4;
double VQup1,VQdn1,VQup2,VQdn2,VQup0,VQdn0;

//VQ Indicator extern variables:
extern   bool     Crash = false;

extern   int      TimeFrame = 0;
extern   int      Length = 5;
extern   int      Method = 3;
extern   int      Smoothing = 1;
extern   int      Filter = 5;

extern   bool     RealTime = true;
extern   bool     Steady  = false;
extern   bool     Color = true;
extern   bool     Alerts = true;
extern   bool     EmailON = false;
extern   bool     SignalPrice = true;
extern   color    SignalPriceBUY = Yellow;
extern   color    SignalPriceSELL = Aqua;
extern   int      CountBars = 20;       
//+------------------------------------------------------------------+
//| expert start function                                                     |
//+------------------------------------------------------------------+
int start()
{
  
bool  PivBuy   =  false;
bool  PivSel   =  false;
bool  ExitBuy  =  false;
bool  ExitSell =  false;

int   cnt,ticket,total,SellValue,BuyValue,i;

static datetime dtBarTime = 0;


if (OrdersTotal()==0) // allows only one trade at a time
{

if (Volume[0] != 1)  //looks at only first tick of new (current) bar
return(0);

VQup1=iCustom(NULL,0,"VQforEA",Crash,TimeFrame,Length,Method,Smoothing,Filter,1,1); //up BUFFER '1'. (for Green Line)
VQdn1=iCustom(NULL,0,"VQforEA",Crash,TimeFrame,Length,Method,Smoothing,Filter,2,1); //dwn BUFFER '2'. (for Red Line)

VQup2=iCustom(NULL,0,"VQforEA",Crash,TimeFrame,Length,Method,Smoothing,Filter,1,2); //up BUFFER '1' - for Green 1 BAR BACK.
VQdn2=iCustom(NULL,0,"VQforEA",Crash,TimeFrame,Length,Method,Smoothing,Filter,2,2); //dwn BUFFER '2' - for Red 1 BAR BACK.
//   Print("RAW VQup1 ",VQup1," VQup2 ",VQup2," VQdn1 ",VQdn1," VQdn2 ",VQdn2);
   
VQup0=iCustom(NULL,0,"VQforEA",Crash,TimeFrame,Length,Method,Smoothing,Filter,1,0);  //curr bar
VQdn0=iCustom(NULL,0,"VQforEA",Crash,TimeFrame,Length,Method,Smoothing,Filter,2,0);  //curr bar

if(VQup1 >300)VQup1=0; //Convert214567... to usable value. //EMPTY_VALUE, most likely
if(VQup2 >300)VQup2=0; //Convert214567... to usable value.

if(VQdn1 >300)VQdn1=0; //Convert214567... to usable value.
if(VQdn2 >300)VQdn2=0; //Convert214567... to usable value.

if(VQup0 >300)VQup0=0; //Convert214567... to usable value.
if(VQdn0 >300)VQdn0=0; //Convert214567... to usable value.

if ( VQdn1>0 && VQdn2 ==0 && VQup1 ==0 && VQup0 == 0)
   {
   //Print("SELL  VQup0 ",VQup0," VQup1 ",VQup1," VQup2 ",VQup2," VQdn0 ",VQdn0," VQdn1 ",VQdn1," VQdn2 ",VQdn2);
   SellValue=1;
   }

if (VQup1 >0 && VQup2 ==0 && VQdn1 ==0 && VQdn0 == 0)
   {
   //Print("BUY   VQup0 ",VQup0," VQup1 ",VQup1," VQup2 ",VQup2," VQdn0 ",VQdn0," VQdn1 ",VQdn1," VQdn2 ",VQdn2);
   BuyValue=1;
   }


   if ( BuyValue==1)
   {

      PivBuy  =  true; PivSel = false;ExitSell= true;
   }
     if (SellValue==1)
   {
      PivSel  =  true; PivBuy = false; ExitBuy = true;  
   }
  total=0;

 if(MM==false)
   {
     double Lot=Lots; 
   }    

  int decimalPlaces = 2;

  if (MM==true)
   {
   Lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,decimalPlaces);
   if (Lot>9) Lot=9;
   }

// OPEN BUY
   for (cnt = 0; cnt < OrdersTotal(); cnt++)
   {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if (OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber) total++;
   }
   if(total<1 && PivBuy == true && ExitBuy == false) 
   {
     ticket=OrderSend(Symbol(),OP_BUY,Lot,Ask,slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,"KikoVQ",MagicNumber,0,Green);
      if(ticket>0)
      {
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) /*Print("BUY order opened : ",OrderOpenPrice());
         else Print("Error opening BUY order : ",GetLastError()); */
         return(0);    
      }
   }

   // OPEN SELL
   for (cnt = 0; cnt < OrdersTotal(); cnt++)
   {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if (OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber) total++;
   }
   if(total<1 && PivSel == true && ExitSell == false) 
   {

      ticket=OrderSend(Symbol(),OP_SELL,Lot,Bid,slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,"KikoVQ",MagicNumber,0,Red);
      if(ticket>0)
      {
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) /*Print("SELL order opened : ",OrderOpenPrice());
         else Print("Error opening SELL order : ",GetLastError());*/ 
         return(0);    
      }
    }
  } //END: if (OrdersTotal

      
return(0);
} 

